<html>
<head>
<title>Ogre::TerrainMaterialGenerator Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html">TerrainMaterialGenerator</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::TerrainMaterialGenerator Class Reference<div class="ingroups"><a class="el" href="group__Terrain.html">Terrain</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::TerrainMaterialGenerator" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Class that provides functionality to generate materials for use with a terrain.  
 <a href="classOgre_1_1TerrainMaterialGenerator.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::TerrainMaterialGenerator:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1TerrainMaterialGenerator__inherit__graph.gif" border="0" usemap="#Ogre_1_1TerrainMaterialGenerator_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1TerrainMaterialGenerator_inherit__map" id="Ogre_1_1TerrainMaterialGenerator_inherit__map">
<area shape="rect" id="node5" href="classOgre_1_1TerrainMaterialGeneratorA.html" title="A TerrainMaterialGenerator which can cope with normal mapped, specular mapped terrain." alt="" coords="5,160,216,189"/><area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="65,5,156,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1TerrainMaterialGenerator-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Inner class which should also be subclassed to provide profile-specific material generation.  <a href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">ProfileList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">List of profiles - NB should be ordered in descending complexity.  <a href="#a337b92bbdb7651a87c2deaaabfee61bd"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a533d059caa8ac039c9591fb47b1ea82e">TerrainMaterialGenerator</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a1de7023a59600699ae10003ec5005fb4">~TerrainMaterialGenerator</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">ProfileList</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a08984aa8f2a4c681a382160853961280">getProfiles</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the list of profiles that this generator supports.  <a href="#a08984aa8f2a4c681a382160853961280"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aaf1237c1f7b754f2c4d1d172c7690508">setActiveProfile</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the active profile by name.  <a href="#aaf1237c1f7b754f2c4d1d172c7690508"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a0580472a86a3c9cadfe6c494e5005854">setActiveProfile</a> (<a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a> *p)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the active <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>.  <a href="#a0580472a86a3c9cadfe6c494e5005854"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a123e89e77062269eb86d4ad09567b5cb">getActiveProfile</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the active profile.  <a href="#a123e89e77062269eb86d4ad09567b5cb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ae6cdf5dafc5bbea8e8241b54689798de">_markChanged</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method - indicates that a change has been made that would require material regeneration.  <a href="#ae6cdf5dafc5bbea8e8241b54689798de"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned long long int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a2582ef7b74f57c667dd9141b4d7ce770">getChangeCount</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of times the generator has undergone a change which would require materials to be regenerated.  <a href="#a2582ef7b74f57c667dd9141b4d7ce770"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <br class="typebreak"/>
<a class="el" href="structOgre_1_1TerrainLayerDeclaration.html">TerrainLayerDeclaration</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a2b588f2e356379764c372ae4c1318b3c">getLayerDeclaration</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the layer declaration that this material generator operates with.  <a href="#a2b588f2e356379764c372ae4c1318b3c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a7f9892827501c4907da1775e3c0c067b">canGenerateUsingDeclaration</a> (const <a class="el" href="structOgre_1_1TerrainLayerDeclaration.html">TerrainLayerDeclaration</a> &amp;decl)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether this generator can generate a material for a given declaration.  <a href="#a7f9892827501c4907da1775e3c0c067b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ab31900b86aac80a5ac2fd040219f1932">isVertexCompressionSupported</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether this material generator supports using a compressed vertex format.  <a href="#ab31900b86aac80a5ac2fd040219f1932"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#af56363e3dbbffde7872cf88b869565ac">requestOptions</a> (<a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the generator to request the options that it needs.  <a href="#af56363e3dbbffde7872cf88b869565ac"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aa9e7fb7cee77cc1bb1d88fa6c3de7f5e">generate</a> (const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate a material for the given terrain using the active profile.  <a href="#aa9e7fb7cee77cc1bb1d88fa6c3de7f5e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#acaa6cd4b06a385638fed2603480d8445">generateForCompositeMap</a> (const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Generate a material for the given composite map of the terrain using the active profile.  <a href="#acaa6cd4b06a385638fed2603480d8445"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a6076c32528ca504993081e75b4da9f92">getMaxLayers</a> (const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the maximum number of layers supported with the given terrain.  <a href="#a6076c32528ca504993081e75b4da9f92"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aaa151085991db558a3e94748356c8156">updateCompositeMap</a> (const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain, const <a class="el" href="group__General.html#gae714035a753a8f484650598dc4143db8">Rect</a> &amp;rect)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Update the composite map for a terrain.  <a href="#aaa151085991db558a3e94748356c8156"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aed0ac64c47fa577fab20e844b02b0aa5">updateParams</a> (const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;mat, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Update parameters for the given terrain using the active profile.  <a href="#aed0ac64c47fa577fab20e844b02b0aa5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a15db830ec2609de8e70e90861a30b8a7">updateParamsForCompositeMap</a> (const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;mat, const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *terrain)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Update parameters for the given terrain composite map using the active profile.  <a href="#a15db830ec2609de8e70e90861a30b8a7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#acfbb5218a477deb4065d0eadd8c1f0c3">setDebugLevel</a> (unsigned int dbg)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the debug level of the material.  <a href="#acfbb5218a477deb4065d0eadd8c1f0c3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ab48af2c30f6b4e04b7f0f33145ebca7f">getDebugLevel</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the debug level of the material.  <a href="#ab48af2c30f6b4e04b7f0f33145ebca7f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#abbe57c1cdc0ff8acb1ab5e837f0aa573">_renderCompositeMap</a> (size_t size, const <a class="el" href="group__General.html#gae714035a753a8f484650598dc4143db8">Rect</a> &amp;rect, const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;mat, const <a class="el" href="classOgre_1_1TexturePtr.html">TexturePtr</a> &amp;destCompositeMap)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Helper method to render a composite map.  <a href="#abbe57c1cdc0ff8acb1ab5e837f0aa573"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Texture.html">Texture</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a87dca7208407e824a01d5e07ea92688f">_getCompositeMapRTT</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">ProfileList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#acdbc4cf5bdba5c6577662581c2d9c990">mProfiles</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a0f04fb94223347d560338399f2fa2cd0">mActiveProfile</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned long long int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ab21a210743846b8dd20799f4324fb882">mChangeCounter</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structOgre_1_1TerrainLayerDeclaration.html">TerrainLayerDeclaration</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a7c256bc180f216bb90f594d3698963a4">mLayerDecl</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ae58d5426a1d4de2fecece9efecc00834">mDebugLevel</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a68016a45555fc8c772c76532d1a74aa9">mCompositeMapSM</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#afb78d081851dbb6945ff07c9c33d48c9">mCompositeMapCam</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Texture.html">Texture</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a85b957996602677758e0ceec23e5bfcc">mCompositeMapRTT</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1ManualObject.html">ManualObject</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#abc10291e0f1514a0964f8f5b090efd67">mCompositeMapPlane</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a537affac1f06bed1d3a5c0d42c6dcd2b">mCompositeMapLight</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class that provides functionality to generate materials for use with a terrain. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Terrains are composed of one or more layers of texture information, and require that a material is generated to render them. There are various approaches to rendering the terrain, which may vary due to: <ul>
<li>
Hardware support (static) </li>
<li>
<a class="el" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a> instances assigned to a particular terrain (dynamic in an editor) </li>
<li>
User selection (e.g. changing to a cheaper option in order to increase performance, or in order to test how the material might look on other hardware (dynamic) </li>
</ul>
Subclasses of this class are responsible for responding to these factors and to generate a terrain material. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>In order to cope with both hardware support and user selection, the generator must expose a number of named 'profiles'. These profiles should function on a known range of hardware, and be graded by quality. At runtime, the user should be able to select the profile they wish to use (provided hardware support is available). </dd></dl>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00155">155</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a337b92bbdb7651a87c2deaaabfee61bd"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::ProfileList" ref="a337b92bbdb7651a87c2deaaabfee61bd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a>*&gt;::type <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">Ogre::TerrainMaterialGenerator::ProfileList</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>List of profiles - NB should be ordered in descending complexity. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00204">204</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a533d059caa8ac039c9591fb47b1ea82e"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::TerrainMaterialGenerator" ref="a533d059caa8ac039c9591fb47b1ea82e" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a533d059caa8ac039c9591fb47b1ea82e">Ogre::TerrainMaterialGenerator::TerrainMaterialGenerator</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a1de7023a59600699ae10003ec5005fb4"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::~TerrainMaterialGenerator" ref="a1de7023a59600699ae10003ec5005fb4" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a1de7023a59600699ae10003ec5005fb4">Ogre::TerrainMaterialGenerator::~TerrainMaterialGenerator</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a87dca7208407e824a01d5e07ea92688f"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::_getCompositeMapRTT" ref="a87dca7208407e824a01d5e07ea92688f" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Texture.html">Texture</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a87dca7208407e824a01d5e07ea92688f">Ogre::TerrainMaterialGenerator::_getCompositeMapRTT</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00379">379</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae6cdf5dafc5bbea8e8241b54689798de"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::_markChanged" ref="ae6cdf5dafc5bbea8e8241b54689798de" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ae6cdf5dafc5bbea8e8241b54689798de">Ogre::TerrainMaterialGenerator::_markChanged</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method - indicates that a change has been made that would require material regeneration. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00247">247</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="abbe57c1cdc0ff8acb1ab5e837f0aa573"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::_renderCompositeMap" ref="abbe57c1cdc0ff8acb1ab5e837f0aa573" args="(size_t size, const Rect &amp;rect, const MaterialPtr &amp;mat, const TexturePtr &amp;destCompositeMap)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#abbe57c1cdc0ff8acb1ab5e837f0aa573">Ogre::TerrainMaterialGenerator::_renderCompositeMap</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gae714035a753a8f484650598dc4143db8">Rect</a> &amp;&#160;</td>
          <td class="paramname"><em>rect</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>mat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TexturePtr.html">TexturePtr</a> &amp;&#160;</td>
          <td class="paramname"><em>destCompositeMap</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Helper method to render a composite map. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">size</td><td>The requested composite map size </td></tr>
    <tr><td class="paramname">rect</td><td>The region of the composite map to update, in image space </td></tr>
    <tr><td class="paramname">mat</td><td>The material to use to render the map </td></tr>
    <tr><td class="paramname">outBox</td><td>The box region of the texture which has been updated, and should be copied into your final texture </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a7f9892827501c4907da1775e3c0c067b"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::canGenerateUsingDeclaration" ref="a7f9892827501c4907da1775e3c0c067b" args="(const TerrainLayerDeclaration &amp;decl)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a7f9892827501c4907da1775e3c0c067b">Ogre::TerrainMaterialGenerator::canGenerateUsingDeclaration</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1TerrainLayerDeclaration.html">TerrainLayerDeclaration</a> &amp;&#160;</td>
          <td class="paramname"><em>decl</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Whether this generator can generate a material for a given declaration. </p>
<p>By default this only returns true if the declaration is equal to the standard one returned from getLayerDeclaration, but if a subclass wants to be flexible to generate materials for other declarations too, it can specify here. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00263">263</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa9e7fb7cee77cc1bb1d88fa6c3de7f5e"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::generate" ref="aa9e7fb7cee77cc1bb1d88fa6c3de7f5e" args="(const Terrain *terrain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aa9e7fb7cee77cc1bb1d88fa6c3de7f5e">Ogre::TerrainMaterialGenerator::generate</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generate a material for the given terrain using the active profile. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00287">287</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a0c47702015bcc5ad4a4920d02a67da2b">Ogre::TerrainMaterialGenerator::Profile::generate()</a>.</p>

</div>
</div>
<a class="anchor" id="acaa6cd4b06a385638fed2603480d8445"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::generateForCompositeMap" ref="acaa6cd4b06a385638fed2603480d8445" args="(const Terrain *terrain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#acaa6cd4b06a385638fed2603480d8445">Ogre::TerrainMaterialGenerator::generateForCompositeMap</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Generate a material for the given composite map of the terrain using the active profile. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00297">297</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a70a4e9bf4482762227e48c061759c1d2">Ogre::TerrainMaterialGenerator::Profile::generateForCompositeMap()</a>.</p>

</div>
</div>
<a class="anchor" id="a123e89e77062269eb86d4ad09567b5cb"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::getActiveProfile" ref="a123e89e77062269eb86d4ad09567b5cb" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a123e89e77062269eb86d4ad09567b5cb">Ogre::TerrainMaterialGenerator::getActiveProfile</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the active profile. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00237">237</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2582ef7b74f57c667dd9141b4d7ce770"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::getChangeCount" ref="a2582ef7b74f57c667dd9141b4d7ce770" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long long int <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a2582ef7b74f57c667dd9141b4d7ce770">Ogre::TerrainMaterialGenerator::getChangeCount</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the number of times the generator has undergone a change which would require materials to be regenerated. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00252">252</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab48af2c30f6b4e04b7f0f33145ebca7f"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::getDebugLevel" ref="ab48af2c30f6b4e04b7f0f33145ebca7f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned int <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ab48af2c30f6b4e04b7f0f33145ebca7f">Ogre::TerrainMaterialGenerator::getDebugLevel</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the debug level of the material. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00367">367</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2b588f2e356379764c372ae4c1318b3c"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::getLayerDeclaration" ref="a2b588f2e356379764c372ae4c1318b3c" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="structOgre_1_1TerrainLayerDeclaration.html">TerrainLayerDeclaration</a>&amp; <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a2b588f2e356379764c372ae4c1318b3c">Ogre::TerrainMaterialGenerator::getLayerDeclaration</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the layer declaration that this material generator operates with. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00256">256</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a6076c32528ca504993081e75b4da9f92"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::getMaxLayers" ref="a6076c32528ca504993081e75b4da9f92" args="(const Terrain *terrain) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#a119732ea9d1e88bbddc47b4ac0fa21cb">uint8</a> <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a6076c32528ca504993081e75b4da9f92">Ogre::TerrainMaterialGenerator::getMaxLayers</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the maximum number of layers supported with the given terrain. </p>
<dl class="note"><dt><b>Note:</b></dt><dd>When you change the options on the terrain, this value can change. </dd></dl>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00308">308</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a4ab7d26991576153fe480c316ccfef86">Ogre::TerrainMaterialGenerator::Profile::getMaxLayers()</a>.</p>

</div>
</div>
<a class="anchor" id="a08984aa8f2a4c681a382160853961280"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::getProfiles" ref="a08984aa8f2a4c681a382160853961280" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">ProfileList</a>&amp; <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a08984aa8f2a4c681a382160853961280">Ogre::TerrainMaterialGenerator::getProfiles</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the list of profiles that this generator supports. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00208">208</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab31900b86aac80a5ac2fd040219f1932"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::isVertexCompressionSupported" ref="ab31900b86aac80a5ac2fd040219f1932" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ab31900b86aac80a5ac2fd040219f1932">Ogre::TerrainMaterialGenerator::isVertexCompressionSupported</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return whether this material generator supports using a compressed vertex format. </p>
<p>This is only possible when using shaders. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00271">271</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="af56363e3dbbffde7872cf88b869565ac"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::requestOptions" ref="af56363e3dbbffde7872cf88b869565ac" args="(Terrain *terrain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#af56363e3dbbffde7872cf88b869565ac">Ogre::TerrainMaterialGenerator::requestOptions</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Triggers the generator to request the options that it needs. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00278">278</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#ad4cbd3a430cdf5ce892ab63ef8ad270b">Ogre::TerrainMaterialGenerator::Profile::requestOptions()</a>.</p>

</div>
</div>
<a class="anchor" id="aaf1237c1f7b754f2c4d1d172c7690508"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::setActiveProfile" ref="aaf1237c1f7b754f2c4d1d172c7690508" args="(const String &amp;name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aaf1237c1f7b754f2c4d1d172c7690508">Ogre::TerrainMaterialGenerator::setActiveProfile</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the active profile by name. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00211">211</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0580472a86a3c9cadfe6c494e5005854"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::setActiveProfile" ref="a0580472a86a3c9cadfe6c494e5005854" args="(Profile *p)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aaf1237c1f7b754f2c4d1d172c7690508">Ogre::TerrainMaterialGenerator::setActiveProfile</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a> *&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the active <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html" title="Inner class which should also be subclassed to provide profile-specific material generation.">Profile</a>. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00228">228</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="acfbb5218a477deb4065d0eadd8c1f0c3"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::setDebugLevel" ref="acfbb5218a477deb4065d0eadd8c1f0c3" args="(unsigned int dbg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#acfbb5218a477deb4065d0eadd8c1f0c3">Ogre::TerrainMaterialGenerator::setDebugLevel</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>dbg</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the debug level of the material. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Sets the level of debug display for this material. What this debug level means is entirely depdendent on the generator, the only constant is that 0 means 'no debug' and non-zero means 'some level of debugging', with any graduations in non-zero values being generator-specific. </dd></dl>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00358">358</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="aaa151085991db558a3e94748356c8156"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::updateCompositeMap" ref="aaa151085991db558a3e94748356c8156" args="(const Terrain *terrain, const Rect &amp;rect)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aaa151085991db558a3e94748356c8156">Ogre::TerrainMaterialGenerator::updateCompositeMap</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="group__General.html#gae714035a753a8f484650598dc4143db8">Rect</a> &amp;&#160;</td>
          <td class="paramname"><em>rect</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Update the composite map for a terrain. </p>
<p>The composite map for a terrain must match what the terrain should look like at distance. This method will only be called in the render thread so the generator is free to render into a texture to support this, so long as the results are blitted into the <a class="el" href="classOgre_1_1Terrain.html" title="The main containing class for a chunk of terrain.">Terrain</a>'s own composite map afterwards. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00323">323</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a9bb28eb51fc5229209a72564315d3eb1">Ogre::TerrainMaterialGenerator::Profile::updateCompositeMap()</a>.</p>

</div>
</div>
<a class="anchor" id="aed0ac64c47fa577fab20e844b02b0aa5"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::updateParams" ref="aed0ac64c47fa577fab20e844b02b0aa5" args="(const MaterialPtr &amp;mat, const Terrain *terrain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#aed0ac64c47fa577fab20e844b02b0aa5">Ogre::TerrainMaterialGenerator::updateParams</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>mat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Update parameters for the given terrain using the active profile. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00335">335</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#a8efea3f1c4506d600d96995ba0d61164">Ogre::TerrainMaterialGenerator::Profile::updateParams()</a>.</p>

</div>
</div>
<a class="anchor" id="a15db830ec2609de8e70e90861a30b8a7"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::updateParamsForCompositeMap" ref="a15db830ec2609de8e70e90861a30b8a7" args="(const MaterialPtr &amp;mat, const Terrain *terrain)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a15db830ec2609de8e70e90861a30b8a7">Ogre::TerrainMaterialGenerator::updateParamsForCompositeMap</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&#160;</td>
          <td class="paramname"><em>mat</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Terrain.html">Terrain</a> *&#160;</td>
          <td class="paramname"><em>terrain</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Update parameters for the given terrain composite map using the active profile. </p>

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00343">343</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html#abcb1087d4d2f5b60ba99a22a86dde5f4">Ogre::TerrainMaterialGenerator::Profile::updateParamsForCompositeMap()</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a0f04fb94223347d560338399f2fa2cd0"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mActiveProfile" ref="a0f04fb94223347d560338399f2fa2cd0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TerrainMaterialGenerator_1_1Profile.html">Profile</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a0f04fb94223347d560338399f2fa2cd0">Ogre::TerrainMaterialGenerator::mActiveProfile</a><code> [mutable, protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00383">383</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab21a210743846b8dd20799f4324fb882"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mChangeCounter" ref="ab21a210743846b8dd20799f4324fb882" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long long int <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ab21a210743846b8dd20799f4324fb882">Ogre::TerrainMaterialGenerator::mChangeCounter</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00384">384</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="afb78d081851dbb6945ff07c9c33d48c9"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mCompositeMapCam" ref="afb78d081851dbb6945ff07c9c33d48c9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Camera.html">Camera</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#afb78d081851dbb6945ff07c9c33d48c9">Ogre::TerrainMaterialGenerator::mCompositeMapCam</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00388">388</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a537affac1f06bed1d3a5c0d42c6dcd2b"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mCompositeMapLight" ref="a537affac1f06bed1d3a5c0d42c6dcd2b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Light.html">Light</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a537affac1f06bed1d3a5c0d42c6dcd2b">Ogre::TerrainMaterialGenerator::mCompositeMapLight</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00391">391</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="abc10291e0f1514a0964f8f5b090efd67"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mCompositeMapPlane" ref="abc10291e0f1514a0964f8f5b090efd67" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1ManualObject.html">ManualObject</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#abc10291e0f1514a0964f8f5b090efd67">Ogre::TerrainMaterialGenerator::mCompositeMapPlane</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00390">390</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a85b957996602677758e0ceec23e5bfcc"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mCompositeMapRTT" ref="a85b957996602677758e0ceec23e5bfcc" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Texture.html">Texture</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a85b957996602677758e0ceec23e5bfcc">Ogre::TerrainMaterialGenerator::mCompositeMapRTT</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00389">389</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a68016a45555fc8c772c76532d1a74aa9"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mCompositeMapSM" ref="a68016a45555fc8c772c76532d1a74aa9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a>* <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a68016a45555fc8c772c76532d1a74aa9">Ogre::TerrainMaterialGenerator::mCompositeMapSM</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00387">387</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae58d5426a1d4de2fecece9efecc00834"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mDebugLevel" ref="ae58d5426a1d4de2fecece9efecc00834" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#ae58d5426a1d4de2fecece9efecc00834">Ogre::TerrainMaterialGenerator::mDebugLevel</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00386">386</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7c256bc180f216bb90f594d3698963a4"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mLayerDecl" ref="a7c256bc180f216bb90f594d3698963a4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structOgre_1_1TerrainLayerDeclaration.html">TerrainLayerDeclaration</a> <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a7c256bc180f216bb90f594d3698963a4">Ogre::TerrainMaterialGenerator::mLayerDecl</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00385">385</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="acdbc4cf5bdba5c6577662581c2d9c990"></a><!-- doxytag: member="Ogre::TerrainMaterialGenerator::mProfiles" ref="acdbc4cf5bdba5c6577662581c2d9c990" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#a337b92bbdb7651a87c2deaaabfee61bd">ProfileList</a> <a class="el" href="classOgre_1_1TerrainMaterialGenerator.html#acdbc4cf5bdba5c6577662581c2d9c990">Ogre::TerrainMaterialGenerator::mProfiles</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html#l00382">382</a> of file <a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreTerrainMaterialGenerator_8h_source.html">OgreTerrainMaterialGenerator.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:12
</p>
</body>
</html>
